var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var cmdm = require('../lib/tfcommand');
var buildifm = require('vso-node-api/interfaces/BuildInterfaces');
var params = require('../lib/parameternames');
function describe() {
    return 'get a list of builds';
}
exports.describe = describe;
function getArguments() {
    return cmdm.formatArgumentsHint([params.PROJECT_NAME], [params.DEFINITION_ID, params.DEFINITION_NAME, params.STATUS, params.TOP]);
}
exports.getArguments = getArguments;
function getCommand() {
    // this just offers description for help and to offer sub commands
    return new BuildGetList;
}
exports.getCommand = getCommand;
// requires auth, connect etc...
exports.isServerOperation = true;
// unless you have a good reason, should not hide
exports.hideBanner = false;
var BuildGetList = (function (_super) {
    __extends(BuildGetList, _super);
    function BuildGetList() {
        _super.apply(this, arguments);
    }
    BuildGetList.prototype.exec = function (args, options) {
        var _this = this;
        var buildapi = this.getWebApi().getQBuildApi();
        var project = args[0] || options[params.PROJECT_NAME];
        this.checkRequiredParameter(project, params.PROJECT_NAME, params.PROJECT_FRIENDLY_NAME);
        var status = options[params.STATUS];
        var top = null;
        if (options[params.TOP]) {
            top = +options[params.TOP];
        }
        var definitions = null;
        var definitionId = +options[params.DEFINITION_ID];
        var definitionName = options[params.DEFINITION_NAME];
        if (definitionId) {
            definitions = [+options[params.DEFINITION_ID]];
        }
        else if (definitionName) {
            return buildapi.getDefinitions(project, definitionName).then(function (defs) {
                definitions = [defs[0].id];
                return _this._getBuilds(buildapi, project, definitions, buildifm.BuildStatus[status], top);
            });
        }
        return this._getBuilds(buildapi, project, definitions, buildifm.BuildStatus[status], top);
    };
    BuildGetList.prototype.output = function (data) {
        if (!data) {
            throw new Error('no build supplied');
        }
        if (!(data instanceof Array)) {
            throw new Error('expected an array of builds');
        }
        data.forEach(function (build) {
            console.log();
            console.log('id   : ' + build.id);
            console.log('definition name: ' + build.definition.name);
            console.log('requested by : ' + build.requestedBy.displayName);
            console.log('status : ' + buildifm.BuildStatus[build.status]);
            console.log('queue time : ' + build.queueTime);
        });
    };
    BuildGetList.prototype._getBuilds = function (buildapi, project, definitions, status, top) {
        // I promise that this was as painful to write as it is to read
        return buildapi.getBuilds(project, definitions, null, null, null, null, null, null, buildifm.BuildStatus[status], null, null, null, null, top, null, null, null, null);
    };
    return BuildGetList;
})(cmdm.TfCommand);
exports.BuildGetList = BuildGetList;
